﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace UpLoadFileDemo.Controllers
{
    public class HomeController : Controller
    {
        //首页
        public ActionResult Index()
        {
            return View();
        }

        //上传文件事件
        [HttpPost]
        public ActionResult UpLoadFileEvent()
        {
            var file = Request.Files;
            return UpLoadFile(file, @"~\Uploadfile\Document\" + DateTime.Now.ToString("yyyy-MM-dd"));
        }

        //上传文件
        public JsonResult UpLoadFile(HttpFileCollectionBase file, string url)
        {
            try
            {
                if (file.Count <= 0)
                {
                    //判断是否添加文件
                    return Json(new { result = "false", message = "请选择需要添加的文件" });
                }

                var newFile = file[0];

                if (!(newFile != null && newFile.ContentLength >= 0))
                {
                    //判断是否为空字节文件
                    return Json(new { result = "false", message = "请选择非空字节的文件" });
                }

                //设置文件保存在服务器上的路径
                var path = Server.MapPath(url);
                if (!Directory.Exists(path))
                {
                    Directory.CreateDirectory(path);
                }

                //拼接路径并且保存
                path = Path.Combine(path, newFile.FileName);
                newFile.SaveAs(path);

                //转换正虚拟路径
                string returnPath = urlToVirtual(path);
                return Json(new { result = "true", message = "上传成功!", path = returnPath, fileName = newFile.FileName });
            }
            catch
            {
                return Json(new { result = "false", message = "上传失败！请联系管理员！" });
            }
        }

        //物理转虚拟路径
        private string urlToVirtual(string imagesurl1)
        {
            //其实这里的tmpRootDir也等于tmpRootDir=Server.MapPath("~/");            
            string tmpRootDir = Server.MapPath(System.Web.HttpContext.Current.Request.ApplicationPath.ToString());//获取程序根目录
            string imagesurl2 = imagesurl1.Replace(tmpRootDir, ""); //转换成相对路径
            imagesurl2 = imagesurl2.Replace(@"\", @"/");
            return imagesurl2;
        }
    }
}
